# -*- coding: utf-8 -*-
from setuphelpers import *

app_schtasks_list = [
    r"\TVT\TVSUUpdateTask",
    r"\TVT\TVSUUpdateTask_UserLogOn",
]


def install():
    bin_name = glob.glob("system_update_*.exe")[0]
    install_exe_if_needed(
        bin_name,
        silentflags="/VERYSILENT /SUPPRESSMSGBOXES /NORESTART /SP-",
        key="TVSU_is1",
        min_version=control.get_software_version(),
    )

    # Disabling Telemetry and adding base configuration (procedure: https://thinkdeploy.blogspot.com/2020/03/system-update-suite-and-mem-part-2.html)
    if iswin64():
        app_reg_path_part = r"SOFTWARE\WOW6432Node\Policies\Lenovo\System Update"
        app_reg_path_user_part = r"SOFTWARE\WOW6432Node\Lenovo\System Update"
    else:
        app_reg_path_part = r"SOFTWARE\Policies\Lenovo\System Update"
        app_reg_path_user_part = r"SOFTWARE\Lenovo\System Update"
    # registry_setstring(HKEY_LOCAL_MACHINE, r'%s\UserSettings\General' % app_reg_path_part, 'AdminCommandLine', '')
    registry_setstring(HKEY_LOCAL_MACHINE, r"%s\UserSettings\General" % app_reg_path_part, "AskBeforeClosing", "NO")
    registry_setstring(HKEY_LOCAL_MACHINE, r"%s\UserSettings\General" % app_reg_path_part, "DisplayLicenseNotice", "NO")
    registry_setstring(HKEY_LOCAL_MACHINE, r"%s\UserSettings\General" % app_reg_path_part, "MetricsEnabled", "NO")
    # registry_setstring(HKEY_LOCAL_MACHINE, r"%s\UserSettings\Scheduler" % app_reg_path_part, "SchedulerAbility", "YES")
    # registry_setstring(HKEY_LOCAL_MACHINE, r"%s\UserSettings\Scheduler" % app_reg_path_part, "SchedulerLock", "SHOW")
    registry_setstring(HKEY_LOCAL_MACHINE, r"%s\UserSettings\Scheduler" % app_reg_path_part, "SchedulerAbility", "NO")
    registry_setstring(HKEY_LOCAL_MACHINE, r"%s\UserSettings\Scheduler" % app_reg_path_part, "SchedulerLock", "HIDE")
    # HKEY_LOCAL_MACHINE\SOFTWARE\WOW6432Node\Lenovo\System Update\Preferences\UserSettings\Scheduler
    registry_setstring(HKEY_LOCAL_MACHINE, r"%s" % app_reg_path_user_part, "FirstTimeRun", "false")
    registry_setstring(HKEY_LOCAL_MACHINE, r"%s\Preferences\UserSettings\General" % app_reg_path_user_part, "EULAAccepted", "true")
    registry_setstring(HKEY_LOCAL_MACHINE, r"%s\Preferences\UserSettings\General" % app_reg_path_user_part, "DisplayLicenseNoticeSU", "NO")
    registry_setstring(HKEY_LOCAL_MACHINE, r"%s\Preferences\UserSettings\Scheduler" % app_reg_path_user_part, "SchedulerSettingChangedByUser", "YES")
    registry_setstring(HKEY_LOCAL_MACHINE, r"%s\Preferences\UserSettings\Scheduler" % app_reg_path_user_part, "RunOn", "WEDNESDAY")
    registry_setstring(HKEY_LOCAL_MACHINE, r"%s\Preferences\UserSettings\Scheduler" % app_reg_path_user_part, "SearchMode", "CRITICAL")
    # registry_setstring(HKEY_LOCAL_MACHINE, r'%s\Preferences\UserSettings\Scheduler' % app_reg_path_user_part, 'SearchMode', 'RECOMMENDED')
    registry_setstring(HKEY_LOCAL_MACHINE, r"%s\Preferences\UserSettings\Scheduler" % app_reg_path_user_part, "NotifyOptions", "NOTIFY")
    # registry_setstring(HKEY_LOCAL_MACHINE, r'%s\Preferences\UserSettings\Scheduler' % app_reg_path_user_part, 'NotifyOptions', 'DOWNLOADANDINSTALL -INCLUDEREBOOT')
    # registry_setstring(HKEY_LOCAL_MACHINE, r'%s\Preferences\UserSettings\Scheduler' % app_reg_path_user_part, 'NotifyOptions', 'DOWNLOADANDINSTALL')

    # Disabling application scheduled tasks
    for task in app_schtasks_list:
        if task_exists(task):
            try:
                disable_task(task)
            except:
                print("Unable to disable the task: %s" % task)
