# -*- coding: utf-8 -*-
from setuphelpers import *
import re


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name

    # https://github.com/microsoft/winget-pkgs/tree/master/manifests/l/Lenovo/SystemUpdate # migrate to winget when possible
    url = "https://community.chocolatey.org/packages/lenovo-thinkvantage-system-update"
    version = bs_find(
        url,
        "button",
        "class",
        "btn btn-success btn-builder d-none d-sm-inline-block",
        proxies=proxies,
    )["version"]
    version = re.search(r"(\d+\.\d+\.\d+)\.\d+", version).group(1)
    download_url = "https://download.lenovo.com/pccbbs/thinkvantage_en/system_update_%s.exe" % version
    latest_bin = download_url.split("/")[-1]
    version = latest_bin.split("_")[-1].replace(".exe", "")

    # Downloading latest binaries
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)

    # Checking version from file
    version_from_file = get_version_from_binary(latest_bin)
    version = version_from_file

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.version = "%s-%s" % (Version(version), control.version.split("-", 1)[-1])
    # control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating or not update-package-sources
    return package_updated
